#!/usr/bin/perl -w
#########################################
# e-Bot 0.3                             #
# Fundado dia 14 de Outubro de 2001     #           
#########################################
# Email: arc4njo@ig.com.br              #
# Email: femello@mac.com                #
# Produzido por OSx & Arc4njo           #
#########################################

#####################################################
# General Configurations                            #
#####################################################

$servidor = 'irc.server.com';			# IRC Server
$nick = 'e-Bot';				# Bot's Nickname
$host = 'e-bot.sourceforge.net';		# Your IP or Hostname
$porta = 6667;					# IRC Server's Port
@canais = ("#perl", "#underground");		# Channel(s) that the bot will join
@admins = ("Arc4njo","OSx", "your_nickname");	# Admins nickname(s). Can be more than one

#####################################################
# NickServ Identification                           #
#####################################################

$possuisenha = 0;			# If the network has nickserv and your bot is registred, set this to 1, otherwise set this to 0
$senhanick = "password";		# If $possuisenha = 1; then fill this variable with the bot's password

#####################################################
# PLUGINS                                           #
#####################################################

$plugindir = '/home/user/e-Bot/plugins';	# Complete path to the "plugins" directory

# Tradutor
$tradutor = 1;			# If you want the babelfish plugin, set this to 1, otherwise set this to 0

# Quotes
$quotes = 1;			# If you run the bot on a unix box and you want the quotes set this to 1, otherwise set this to 0
$random = 600;			# Delay in which the bot will send a random quote to the channel(s) (in seconds).
$timer = 0;			# Set this to 1 if you want the bot to say a random quote from time to time($random).

#####################################################
# Don't touch anything below this                   #
#####################################################

$DEBUG = 0;                               
$rodo = time;                             
$versao = "0.3";                          

$SIG{INT} = \&desconectar;

use Socket;

if ($ARGV[0] eq "-d" or $ARGV[0] eq "--debug") {
      $DEBUG = 1;
      ilog("Starting in debug mode...\n");
} else {
      $DEBUG = 0;
      ilog("Starting in normal mode...\n");
}

sub dlog {
   print STDOUT "[SOCK] $_[0]";
}

&conectar;

sub conectar {
   while (1) {
      $iaddr = inet_aton($servidor); $paddr = sockaddr_in($porta, $iaddr); $proto = getprotobyname('tcp');
      socket(IRC_SOCK, PF_INET, SOCK_STREAM, $proto) or die "Unable to creat socket: $!\n";
      connect(IRC_SOCK, $paddr) or print "Unable to connect: trying again..\n\n" and next;
      ilog("Connected!\n");
      &login;
      while (<IRC_SOCK>) {
         &parse($_);
     }
      close IRC_SOCK;
      ilog("Lost connection, reconnecting...\n");
      $login = undef;
      sleep(2);
   }
}   
    
sub login {

   raw("NICK $nick");
   raw("USER $nick $host $servidor :$nick");
   ilog("Connecting as $nick\n");
   
   if ($quotes eq "1" && $timer eq "1") {
     unless ($pid = fork) {
        unless (fork) {   
        exec();
        &funcao_1;
        sub funcao_1 {
                        open (QUOTE, "<$plugindir/quotes/quotes.txt") || print("$!");
        @line=<QUOTE>;
                        close (QUOTE);
        srand;
                        $array = $line[int rand(@line)];
                        my ($numero,$nick,$quote,@quando) = split (/\|/, $array);
			foreach $canal (@canais) {
			raw("PRIVMSG $canal :$quote");
			}
        &funcao_2;
        }
        sub funcao_2 {
        sleep($random);
        &funcao_1;
        }
                    exit 0;
                }
                exit 0;
            }
                   waitpid($pid,0);
 }
}

sub ilog {
   print STDOUT "[INFO] $_[0]";
}

sub raw {
if ($DEBUG) { dlog(">> \($_[0]\)\n"); }
   select(IRC_SOCK);
   $| = 1;
   print IRC_SOCK "$_[0]\n";
}

sub parse {
   chop($_);
   chop($_);

   if ($DEBUG) {
      dlog("<< \($_\)\n");
   }

   if (/^PING \:(.+)/) {
      raw("PONG :$1");

   if (!$login) {

   if ($possuisenha eq "1") {
           raw("PRIVMSG NickServ :identify $senhanick");
           ilog("Identifying nick...\n");
   }
	foreach $canal (@canais) {
	raw("JOIN $canal");
	ilog("Joining $canal\n");
	}
   }

      print "\n";
      $login = 1;

  } elsif (/^\:(.+?)!(.+?)@(.+?) KICK #(.+?) \Q$nick\E \:(.+?)/) {
	raw("JOIN #$4");

  } elsif (/^\:(.+?)\!.+?\@.+? PRIVMSG \Q$nick\E \:.?VERSION.?/) {

      raw("NOTICE $1 :VERSION e-Bot $versao [OSx & Arc4njo]");

  } 
  
#####################################################
# PLUGIN: COMANDOS GERAIS                           #
#####################################################

  if (/^\:(.+?)!(.+?)@(.+?) PRIVMSG (.+?) \:(.+)/) {

        $privmsg{from} = $1; 
        $privmsg{user} = $2;
        $privmsg{host} = $3;
        $privmsg{rcpt} = $4; 
        $privmsg{text} = $5;
        $args = $privmsg{text};
        $from = $privmsg{from};
	$seu_host = $privmsg{host};

	foreach $admin (@admins) {
        if ($admin eq $1) {

    if ($args =~ /^!restart/) {
           raw("QUIT Restarting...");
           ilog("Restarting...\n");

   } if ($args =~ /^!time/) {
	    
	    @localtime = localtime(time);
	    $localtime[5] += 1900;
	    $localtime[4] += 1;
	    $localtime[0] = sprintf("%02d",$localtime[0]);
	    $localtime[1] = sprintf("%02d",$localtime[1]);
	    $localtime[2] = sprintf("%02d",$localtime[2]);
	    $data_hora = "$localtime[3]/$localtime[4]/$localtime[5] - $localtime[2]:$localtime[1]:$localtime[0]";

	    raw("PRIVMSG $from :(data/hora) \002$data_hora\002");
            ilog("Telling date/hour to $from in private...\n");

    } if ($args =~ /^!uptime/) {
          $elapsed = time - $rodo; 
          $uptime = int($elapsed / 86400) . " day(s), "; $elapsed = $elapsed % 86400; $uptime .= int($elapsed / 3600) . " hour(s), "; $elapsed = $elapsed % 3600; $uptime .= int($elapsed / 60) . " minute(s), "; $elapsed = $elapsed % 60; $uptime .= $elapsed . " second(s)";
            raw("PRIVMSG $from :Uptime: \002$uptime\002");
            ilog("Telling uptime to $from in private...\n");
       
    } if ($args =~ /^!join/) {
           $canal = substr($args, 5);
           raw("JOIN $canal");
           ilog("Joining $canal...\n");

    } if ($args =~ /^!part/) {
           $canal = substr($args, 5);
           raw("PART $canal");
           ilog("Parting $canal...\n");

    } if ($args =~ /^!rejoin/) {
	   $canal = substr($args, 8);
	   raw("PART $canal");
	   raw("JOIN $canal");
	   ilog("Rejoining $canal...\n");

    } if ($args =~ /^!msg/) {
         my ($msg,$nc,@mensagem) = split(/ /, $args);
           raw("PRIVMSG $nc :@mensagem");
           ilog("Message sent to $nc...\n");

    } if ($args =~ /^!nick/) {
           $nick = substr($args, 5);
           raw("NICK $nick");
           ilog("Changed nick to $nick...\n");

    } if ($args =~ /^!away on/) {
           @mensagem = substr($args, 9);
           raw("AWAY :@mensagem");
           ilog("I'm away...\n");

    } if ($args =~ /^!away off/) {
           raw("AWAY");
           ilog("I'm back!\n");

    } if ($args =~ /^!op/) {
         my ($comando,$canal,$nick) = split(/ /, $args);
           raw("MODE $canal +o $nick"); 
           ilog("Giving op to $nick in $canal...\n");

    } if ($args =~ /^!deop/) {
         my ($comando,$canal,$nick) = split(/ /, $args);
           raw("MODE $canal -o $nick");  
           ilog("Taking op from $nick in $canal...\n");

    } if ($args =~ /^!voice/) {
         my ($comando,$canal,$nick) = split(/ /, $args);
           raw("MODE $canal +v $nick");
           ilog("Giving voice to $nick in $canal...\n");
   
    } if ($args =~ /^!devoice/) {
         my ($comando,$canal,$nick) = split(/ /, $args);
           raw("MODE $canal -v $nick");   
           ilog("Taking voice from $nick in $canal...\n");

    } if ($args =~ /^!kick/) {
         my ($comando,$canal,$nick,@motivo) = split(/ /, $args);
           raw("KICK $canal $nick :@motivo");
           ilog("Kicking $nick from $canal...\n");

    } if ($args =~ /^!ban/) {
         my ($comando,$canal,$nick) = split(/ /, $args);
           raw("MODE $canal +b $nick*!*?*@*");   
           ilog("Banned $nick from $canal...\n");

    } if ($args =~ /^!unban/) {
         my ($comando,$canal,$host) = split(/ /, $args);
           raw("MODE $canal -b $host");   
           ilog("Unbanned $host from $canal...\n");

    } if ($args =~ /^!kb/) {
         my ($comando,$canal,$nick,@motivo) = split(/ /, $args);
           raw("MODE $canal +b $nick*!*?*@*");  
           raw("KICK $canal $nick :@motivo"); 
           ilog("Kickbaning $nick from $canal...\n");

    } if ($args =~ /^!invite/) {
         my ($comando,$canal,$nick) = split(/ /, $args);
           raw("INVITE $canal $nick");   
           ilog("Inviting $nick to enter $canal...\n");

    } if ($args =~ /^!modo/) {
    	 my ($comando,$canal,$modo) = split(/ /, $args);
	   raw("MODE $canal $modo");
	   ilog("Changing modes($modo) in $canal...\n");

    } if ($args =~ /^!topico/) {
    	 my ($comando,$canal,@topico) = split(/ /, $args);
	   raw("TOPIC $canal :@topico");
	   ilog("Changing the topic in $canal to \"@topico\"...\n");

    } if ($args =~ /^!host/) {
	$host = substr($args, 6);
	if ($host =~ /[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/) {
	$lhost = `host $host | awk '{print \$5}'`;
	chomp($lhost);
	} else {
	$lhost = `host $host | awk '{print \$4}'`;
	chomp($lhost);
	}
	raw("PRIVMSG $from :( \002$host\002 ) has address \002$lhost\002");

    } if ($args =~ /^!quit/) {
           @mensagem = substr($args, 6);
              raw("QUIT :@mensagem");
	      print STDOUT "\n";
	      ilog("Interrupt caught: cleaning up...\n");
	      close(IRC_SOCK);
	      ilog("Disconnected!.\n");
	      ilog("Bye.\n\n");
	      exit(0);
    }
   }
  }
 }

#####################################################
# PLUGIN: TRADUTOR                                  #
#####################################################

if ($tradutor eq "1") {
use LWP::Simple;

if (/^:([^: ]*)!([^: ]*) PRIVMSG ([^: ]+) :(.*)$/) {

	$privmsg{from} = $1;
	$privmsg{host} = $2;
	$privmsg{chan} = $3;
	$privmsg{text} = $4;
	$privmsg{host} =~ /(.*)\@(.*)/;
	$privmsg{ident} = $2;
	$args = $privmsg{text};
	$from = $privmsg{from};
	$seu_host = $privmsg{host};
	$seu_ident = $privmsg{ident};

        if ($args =~ /^!ajuda tradutor/) {
	        raw("PRIVMSG $from :To translate a text type:");
	        raw("PRIVMSG $from :\002!tradutor en_zh text\002 (English to Chinese)");
	        raw("PRIVMSG $from :\002!tradutor en_fr text\002 (English to French)");
	        raw("PRIVMSG $from :\002!tradutor en_de text\002 (English to German)");
	        raw("PRIVMSG $from :\002!tradutor en_it text\002 (English to Italian)");
	        raw("PRIVMSG $from :\002!tradutor en_ja text\002 (English to Japonese)");
	        raw("PRIVMSG $from :\002!tradutor en_ko text\002 (English to Korean)");
	        raw("PRIVMSG $from :\002!tradutor en_pt text\002 (English to Portuguese)");
	        raw("PRIVMSG $from :\002!tradutor en_es text\002 (English to Spanish)");
	        raw("PRIVMSG $from :\002!tradutor zh_en text\002 (Chinese to English)");
	        raw("PRIVMSG $from :\002!tradutor fr_en text\002 (French to English)");
	        raw("PRIVMSG $from :\002!tradutor de_en text\002 (German to English)");
	        raw("PRIVMSG $from :\002!tradutor it_en text\002 (Italian to English)");
	        raw("PRIVMSG $from :\002!tradutor ja_en text\002 (Japonese to English)");
	        raw("PRIVMSG $from :\002!tradutor ko_en text\002 (Korean to English)");
	        raw("PRIVMSG $from :\002!tradutor pt_en text\002 (Portuguese to English)");
	        raw("PRIVMSG $from :\002!tradutor ru_en text\002 (Russian to English)");
	        raw("PRIVMSG $from :\002!tradutor es_en text\002 (Spanish to English)");
                raw("PRIVMSG $from :End of commands");

        } if ($args =~ /^!tradutor/) {
           my ($tradutor,$lingua,@texto) = split(/ /, $args);

           $traduz = get("http://babel.altavista.com/tr?doit=done&tt=urltext&urltext=@texto&url=http%3A%2F%2F&lp=$lingua");

           my ($no,$traduz) = split(/<textarea rows="3" wrap=virtual cols="56" name="q">/,$traduz);
           ($traduz,$no) = split(/<\/textarea>/,$traduz);

        if ($lingua eq "en_zh") {
           raw("PRIVMSG $from :Translating text from \002English\002 to \002Chinese\002");
           raw("PRIVMSG $from : ");
           raw("PRIVMSG $from :\002Text in English\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in Chinese\002 -> $traduz");

        } if ($lingua eq "en_fr") {
           raw("PRIVMSG $from :Translating text from \002English\002 to \002French\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in English\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in French\002 -> $traduz");

        } if ($lingua eq "en_de") {
           raw("PRIVMSG $from :Translating text from \002English\002 to \002German\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in English\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in German\002 -> $traduz");

        } if ($lingua eq "en_it") {
           raw("PRIVMSG $from :Translating text from \002English\002 to \002Italian\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in English\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in Italian\002 -> $traduz");

        } if ($lingua eq "en_ja") {
           raw("PRIVMSG $from :Translating text from \002English\002 to \002Japonese\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in English\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in Japonese\002 -> $traduz");

        } if ($lingua eq "en_ko") {
           raw("PRIVMSG $from :Translating text from \002English\002 to \002Korean\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in English\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in Korean\002 -> $traduz");

        }  if ($lingua eq "en_pt") {
           raw("PRIVMSG $from :Translating text from \002English\002 to \002Portuguese\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in English\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in Portuguese\002 -> $traduz");

        }  if ($lingua eq "en_es") {
           raw("PRIVMSG $from :Translating text from \002English\002 to \002Spanish\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in English\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in Spanish\002 -> $traduz");

        }  if ($lingua eq "zh_en") {
	   raw("PRIVMSG $from :Translating text from \002Chinese\002 to \002English\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in Chinese\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in English\002 -> $traduz");

        }  if ($lingua eq "fr_en") {
	   raw("PRIVMSG $from :Translating text from \002French\002 to \002English\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in French\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in English\002 -> $traduz");

        }  if ($lingua eq "de_en") {
	   raw("PRIVMSG $from :Translating text from \002German\002 to \002English\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in German\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in English\002 -> $traduz");

        }  if ($lingua eq "it_en") {
	   raw("PRIVMSG $from :Translating text from \002Italian\002 to \002English\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in Italian\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in English\002 -> $traduz");

        }  if ($lingua eq "ja_en") {
	   raw("PRIVMSG $from :Translating text from \002Japonese\002 to \002English\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in Japonese\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in English\002 -> $traduz");

        }  if ($lingua eq "ko_en") {
	   raw("PRIVMSG $from :Translating text from \002Korean\002 to \002English\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in Korean\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in English\002 -> $traduz");

        }  if ($lingua eq "pt_en") {
	   raw("PRIVMSG $from :Translating text from \002Portuguese\002 to \002English\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in Portuguese\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in English\002 -> $traduz");

        }  if ($lingua eq "ru_en") {
	   raw("PRIVMSG $from :Translating text from \002Russian\002 to \002English\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in Russian\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in English\002 -> $traduz");

        }  if ($lingua eq "es_en") {
	   raw("PRIVMSG $from :Translating text from \002Spanish\002 to \002English\002");
	   raw("PRIVMSG $from : ");
	   raw("PRIVMSG $from :\002Text in Spanish\002 -> @texto");
           raw("PRIVMSG $from :\002Translation in English\002 -> $traduz");
        }
           ilog("Translating text to $from...\n");
       }
 }
}

#####################################################
# PLUGIN: QUOTES                                    #
#####################################################

if ($quotes eq "1") {

if (/^:([^: ]*)!([^: ]*) PRIVMSG ([^: ]+) :(.*)$/) {
	$privmsg{from} = $1;
	$privmsg{host} = $2;
	$privmsg{chan} = $3;
	$privmsg{text} = $4;
	$privmsg{host} =~ /(.*)\@(.*)/;
	$privmsg{ident} = $2;
	$args = $privmsg{text};
	$from = $privmsg{from};
	$canal = $privmsg{chan};
	$seu_host = $privmsg{host};
	$seu_ident = $privmsg{ident};

        if ($args =~ /^!ajuda quotes/) {
        raw("PRIVMSG $from :Below are the commmands for the Quotes plugin:");
        raw("PRIVMSG $from :\002!quote phrase/word\002        -> Search for a quote");
        raw("PRIVMSG $from :\002!addquote phrase/word\002     -> Add a quote (Admins)");
        raw("PRIVMSG $from :\002!delquote number\002          -> Delete a quote (Admins)");
        raw("PRIVMSG $from :\002!rquote\002                   -> Displays random quotes");
	raw("PRIVMSG $from :\002!nquote\002                   -> Displays the total number of quotes");
        raw("PRIVMSG $from  :End of Quotes commands");


        } if ($args =~ /^!rquote/) {

        open (QUOTE, "<$plugindir/quotes/quotes.txt") || print("$!");
        @line=<QUOTE>;
        close (QUOTE);
        srand;

        $array = $line[int rand(@line)];
        ($numero,$nick,$quote,@quando) = split (/\|/, $array);

         raw("PRIVMSG $canal :$quote");

	} if ($args =~ /^!nquotes/) {

	open(DATA, "<$plugindir/quotes/quotes.txt");
	$linhas = 0;
		while (<DATA>) {
			next if length($_) < 0;
			$linhas++;
		}
	close(DATA);

	$contador = $linhas;

	raw("PRIVMSG $canal :Total number of quotes -> \002$contador\002");
	}

	foreach $admin (@admins) {
	if ($admin eq $from) {

        if ($args =~ /^!addquote/) {
            $quote = substr($args, 10);

        @localtime = localtime(time);
	chomp(@localtime);
	$localtime[5] += 1900;
	$localtime[4] += 1;
	$localtime[0] = sprintf("%02d",$localtime[0]);
	$localtime[1] = sprintf("%02d",$localtime[1]);
	$localtime[2] = sprintf("%02d",$localtime[2]);
	$data_hora = "$localtime[3]/$localtime[4]/$localtime[5] - $localtime[2]:$localtime[1]:$localtime[0]";

         open(DATA, "$plugindir/quotes/quotes.txt") || print("$!");
         @data=<DATA>;
         close(DATA);

         $numero = $data[$#data];
	 $numero++;

         open(DATA, ">>$plugindir/quotes/quotes.txt") || print("$!");
         print DATA "$numero|$from!$seu_host|$quote|$data_hora\n";
         close(DATA);

           raw("NOTICE $from :Quote number\002 $numero \002by\002 $from\002.");
           ilog("Quote added by $from...\n");

         }

         if ($args =~ /^!delquote/) {

         $numero = substr($args, 10);

         open(DAT, "$plugindir/quotes/quotes.txt") || print("$!");
         @lines =<DAT>;
         close(DAT);

         open(DAT, ">$plugindir/quotes/quotes.txt") || print("$!");
           foreach $x (@lines) {
            ($linha,$nick,$quote) = split(/\|/, $x);
               unless ($linha =~ /$numero/i) {
                 print DAT "$x";
	           }
         }
         close(DAT);

         raw("NOTICE $from :Quote\002 $numero \002deleted by\002 $from\002!");
         ilog("Quote $numero deleted by $from...\n");

   }
  }

         } if ($args =~ /^!quote/) {

         $qbusca = substr($args, 7);

         open(INF,"$plugindir/quotes/quotes.txt") || print("$!");
	 @data = <INF>;
	 close(INF);

         raw("NOTICE $from :Search results for\002 $qbusca\002:");

         @resultados = grep(/$qbusca/i,@data);
         if ($#resultados >= 0) {
           foreach $x (@resultados) {
           ($numero,$nick,$quote,@quando) = split(/\|/, $x);
	   chomp(@quando);
	     raw("NOTICE $canal :\002$numero\002. $quote");
	     raw("NOTICE $canal :\002Author:\002 $nick");
	     raw("NOTICE $canal :\002Added:\002 @quando");
	  }
	 } else {
	     raw("NOTICE $from :No quotes matching\002 $qbusca\002!");
         }
         ilog("Quotes search made by $from...\n");
       }
 }
}

##################
# FINAL          #
##################

sub desconectar {
   raw("QUIT :I had to kill myself :( ");
   close(IRC_SOCK);
   exit(0);
 }
}
